'*************************
' Moodlight V.3          *
' last update 23.11.2009 *
'*************************

$regfile = "m8def.dat"                                      
$crystal = 8000000                                          'Quarz ( Intern OC mit (8,0 MHz)

Dim Pwmctr As Byte                                          'Variablen Definieren
Dim Rot As Byte
Dim Gruen As Byte
Dim Blau As Byte

Config Timer0 = Timer , Prescale = 1                        'Timer Einschalten - Deklarieren
On Ovf0 Pwm_interrupt                                       'PWM Interrupt Deklarieren
Enable Ovf0                                                 'Timer berlauf Interrupt Einschalten
Enable Interrupts                                           'Interrupts einschalten

Ddrb = &B11111111                                           ' PORTB as output
Ddrc = &B11111111                                           ' PORTC as output
Ddrd = &B11111111                                           ' PORTD as output

Portb = 0
Portc = 0
Portd = 0

Portb.0 = 0

'*******************
'***Hauptprogramm***
'*******************

Do

'Grn einfaden
'-------------
Do                                                          'Beginne den
 Incr Gruen                                                 'PWM Counter um 1 erhhen
 Gosub Zeit                                                 'Fadezeit aus Unterprogramm "Zeit" lesen (Geschwindigkeit mit der der PWM Couter zhlen soll)
Loop Until Gruen > 254                                      'PWM Counter solange um 1 erhhen bis Grn den Wert 254 erreicht hat

'Rot ausfaden
'------------                                               'Beginne den
Do                                                          'PWM Counter um 1 verringern
 Decr Rot                                                   'Fadezeit aus Unterprogramm "Zeit" lesen (Geschwindigkeit mit der der PWM Couter zhlen soll)
 Gosub Zeit                                                 'PWM Counter solange um 1 verringern bis Rot den Wert 0 erreicht hat
Loop Until Rot = 0

'Blau einfaden
'-------------
Do                                                          'Beginne den
 Incr Blau                                                  'PWM Counter um 1 zu erhhen
 Gosub Zeit                                                 'Fadezeit aus dem Unterprogramm "Zeit" lesen (Geschwindigkeit mit der der PWM Couter zhlen soll)
Loop Until Blau > 254                                       'PWM Counter solange um 1 erhhen bis Blau den Wert 254 erreicht hat

'grn ausfaden
'-------------
Do                                                          'Beginne den
 Decr Gruen                                                 'PWM Counter um 1 zu verringern
 Gosub Zeit                                                 'Fadezeit aus dem Unterprogramm "Zeit" lesen (Geschwindigkeit mit der der PWM Counter zhlen soll)
Loop Until Gruen = 0                                        'PWM Counter solange um 1 Verringern bis Grn den Wert 0 Erreicht hat

'Rot einfaden
'------------
Do                                                          'Beginne den
 Incr Rot                                                   'PWM Counter um 1 zu erhhen
 Gosub Zeit                                                 'Fadezeitaus dem Unterporgramm "Zeit" lesen (Geschwindigkeit mir der der PWM Counter zhlen soll)
Loop Until Rot > 254                                        'PWM Counter solange um 1 erhhen bis Rot den Wert 254 erreicht hat

'Blau ausfaden
'-------------
Do                                                          'Beginne den
 Decr Blau                                                  'PWM Counter um 1 zu verringern
 Gosub Zeit                                                 'Fadezeit aus dem Unterprogramm "Zeit" Lesen (Geschwindigkeit mit der der PWM Counter zhlen soll)
Loop Until Blau = 0                                         'PWM Counter solange um 1 verringern bis Blau den Wert 0 erreicht hat

Loop

'************
'**Fadezeit**
'************
Zeit:                                                       'Unterprogramm "Zeit"

 Waitms 1
                                                                      'Zeit fr den Farbbergang (PWM Counter Zhlgeschwindigkeit)
Return                                                      'Rcksprung ins Hauptprogramm

Pwm_interrupt:                                              'PWM Interrupt
Incr Pwmctr
If Rot > Pwmctr Then Set Portd.7 Else Reset Portd.7
If Rot > Pwmctr Then Set Portd.4 Else Reset Portd.4
If Rot > Pwmctr Then Set Portd.1 Else Reset Portd.1
If Rot > Pwmctr Then Set Portc.2 Else Reset Portc.2

If Gruen > Pwmctr Then Set Portd.6 Else Reset Portd.6
If Gruen > Pwmctr Then Set Portd.3 Else Reset Portd.3
If Gruen > Pwmctr Then Set Portd.0 Else Reset Portd.0
If Gruen > Pwmctr Then Set Portc.1 Else Reset Portc.1

If Blau > Pwmctr Then Set Portd.5 Else Reset Portd.5
If Blau > Pwmctr Then Set Portd.2 Else Reset Portd.2
If Blau > Pwmctr Then Set Portc.3 Else Reset Portc.3
If Blau > Pwmctr Then Set Portc.0 Else Reset Portc.0

Return